ParentChild Class Referenceabstract

`#include <ParentChild.h>`

Inheritance diagram for ParentChild:
Collaboration diagram for ParentChild:

## Public Member Functions

| ParentChild ()
virtual | ~ParentChild ()
const std::vector< std::vector< std::string > > & | GetComboKeys (const std::string &catName)
std::vector< std::vector< std::vector< std::string > > > & | GetChildrenKeys (const std::vector< std::string > &parComboKey)
void | GetParents (std::vector< std::vector< std::string > > &parParKeys, std::vector< std::vector< std::string > > &comboComboKeys, const std::string &childCat)
void | GetLinkGroupIdLabel (std::string &linkGroupIdLabel, const std::vector< std::string > &parKeys, const std::vector< std::string > &childKeys)
bool | IsParKeyPresent (const std::vector< std::string > &parKey, const std::string &childCatName)
bool | IsInParentComboKeys (const std::string &itemName)

## Public Attributes

ISTable * | _groupTableP
ISTable * | _groupListTableP

## Protected Member Functions

void | GetComboKeys (const std::string &parCatName, const unsigned int maxKeyGroup, ISTable &keysTable, std::vector< std::vector< std::string > > &comboKeys, std::vector< std::string > &parKeys)
virtual void | GetParentCifItems (std::vector< std::string > &parCifItems, const std::string &cifItemName)=0
void | AddParentCategoryToItemLinkedGroup (ISTable &itemLinkedGroup, ISTable &itemLinkedGroupList)
void | CreateAllRelations (ISTable &itemLinkedGroup, ISTable &itemLinkedGroupList)
void | ISTableFindPairs (std::map< std::string, std::vector< std::vector< std::string > > > &childrenKeys, const std::vector< std::string > &parKeys, ISTable &itemLinkedGroupList)
void | UpdateMap (std::map< std::string, std::vector< std::vector< std::string > > > &childrenKeys, const std::string &childCat, std::vector< std::string > &childKeys)
void | UpdateParComboKeys (const std::string &parName, std::vector< std::string > &parKeys)
void | UpdateRelations (std::vector< std::string > &parKeys, std::vector< std::vector< std::string > > &comboKeys)
bool | KeysMatch (const std::vector< std::string > &firstKey, const std::vector< std::string > &secondKey)

## Protected Attributes

std::map< std::string, std::vector< std::vector< std::string > > > | _parComboKeys
std::map< std::vector< std::string >, std::vector< std::vector< std::vector< std::string > > > > | _relations

## Constructor & Destructor Documentation

## ParentChild()

ParentChild::ParentChild | ( |  | ) |

## ~ParentChild()

virtual ParentChild::~ParentChild | ( |  | ) |

virtual

## Member Function Documentation

## AddParentCategoryToItemLinkedGroup()

void ParentChild::AddParentCategoryToItemLinkedGroup | ( | ISTable & | itemLinkedGroup,
|  | ISTable & | itemLinkedGroupList
| ) |  |

protected

## CreateAllRelations()

void ParentChild::CreateAllRelations | ( | ISTable & | itemLinkedGroup,
|  | ISTable & | itemLinkedGroupList
| ) |  |

protected

## GetChildrenKeys()

std::vector<std::vector<std::vector<std::string> > >& ParentChild::GetChildrenKeys | ( | const std::vector< std::string > & | parComboKey | ) |

## GetComboKeys() [1/2]

const std::vector<std::vector<std::string> >& ParentChild::GetComboKeys | ( | const std::string & | catName | ) |

## GetComboKeys() [2/2]

void ParentChild::GetComboKeys | ( | const std::string & | parCatName,
|  | const unsigned int | maxKeyGroup,
|  | ISTable & | keysTable,
|  | std::vector< std::vector< std::string > > & | comboKeys,
|  | std::vector< std::string > & | parKeys
| ) |  |

protected

## GetLinkGroupIdLabel()

void ParentChild::GetLinkGroupIdLabel | ( | std::string & | linkGroupIdLabel,
|  | const std::vector< std::string > & | parKeys,
|  | const std::vector< std::string > & | childKeys
| ) |  |

## GetParentCifItems()

virtual void ParentChild::GetParentCifItems | ( | std::vector< std::string > & | parCifItems,
|  | const std::string & | cifItemName
| ) |  |

protected pure virtual

Implemented in CifParentChild, and DictParentChild.

## GetParents()

void ParentChild::GetParents | ( | std::vector< std::vector< std::string > > & | parParKeys,
|  | std::vector< std::vector< std::string > > & | comboComboKeys,
|  | const std::string & | childCat
| ) |  |

## IsInParentComboKeys()

bool ParentChild::IsInParentComboKeys | ( | const std::string & | itemName | ) |

## IsParKeyPresent()

bool ParentChild::IsParKeyPresent | ( | const std::vector< std::string > & | parKey,
|  | const std::string & | childCatName
| ) |  |

## ISTableFindPairs()

void ParentChild::ISTableFindPairs | ( | std::map< std::string, std::vector< std::vector< std::string > > > & | childrenKeys,
|  | const std::vector< std::string > & | parKeys,
|  | ISTable & | itemLinkedGroupList
| ) |  |

protected

## KeysMatch()

bool ParentChild::KeysMatch | ( | const std::vector< std::string > & | firstKey,
|  | const std::vector< std::string > & | secondKey
| ) |  |

protected

## UpdateMap()

void ParentChild::UpdateMap | ( | std::map< std::string, std::vector< std::vector< std::string > > > & | childrenKeys,
|  | const std::string & | childCat,
|  | std::vector< std::string > & | childKeys
| ) |  |

protected

## UpdateParComboKeys()

void ParentChild::UpdateParComboKeys | ( | const std::string & | parName,
|  | std::vector< std::string > & | parKeys
| ) |  |

protected

## UpdateRelations()

void ParentChild::UpdateRelations | ( | std::vector< std::string > & | parKeys,
|  | std::vector< std::vector< std::string > > & | comboKeys
| ) |  |

protected

## Member Data Documentation

## _groupListTableP

ISTable* ParentChild::_groupListTableP

## _groupTableP

ISTable* ParentChild::_groupTableP

## _parComboKeys

std::map<std::string, std::vector<std::vector<std::string> > > ParentChild::_parComboKeys

protected

## _relations

std::map<std::vector<std::string>, std::vector<std::vector<std::vector<std::string> > > > ParentChild::_relations

protected

The documentation for this class was generated from the following file:

- rcsb/ParentChild.h